#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

void print_arr(int *arr, int size);
int *unknown_size_bad(void);
int *unknown_size_better(int *size, int *used, int increment);
void lets_go_2d(int size); 

int main()
{
    int size = 5;
    int used = 0;
    int increment = 5;
    int *arr = NULL;

    //arr = unknown_size_bad();

    arr = unknown_size_better(&size, &used, increment);
    print_arr(arr, used);
}

void print_arr(int *arr, int size)
{
    fprintf(stdout, "-------------------");

    for (int i = 0; i < size; i++) {
        fprintf(stdout, "- %d\n", arr[i]);
    }
}

int *unknown_size_bad(void)
{
    // Jaké jsou nevýhody statické alokace?

    // - 
    // - 
    // - 

    int size = 5;

    int arr[size];

    for (int i = 0; i < size; i++) {
        fscanf(stdin, " %d", &arr[i]);
    }

    print_arr(arr, size);

    // Co když budeme chtít vrátit toto pole a dále s ním pracovat?
    return arr;
}

int *unknown_size_better(int *size, int *used, int increment)
{
    // Řešení => dynamická alokace
    
    // Malloc
    int *arr = (int *) malloc(*size * sizeof(int));

    // Jak zajistit, že se paměť systému vrátí?

    // Vždy kontrolujte návratové hodnoty!
    if (arr == NULL) {
        return NULL;
    }

    while (scanf(" %d", &arr[*used]) == 1) {
        ++(*used);

        if (*used == *size) {

            // Je tohle v pořádku?
            int* new_arr;
            new_arr = (int *) realloc(arr, (size_t)(*size + increment) * sizeof(int));

            if (new_arr == NULL) {
                free(arr);
                return NULL;
            }

            arr = new_arr;
            new_arr = NULL;

            *size += increment;

            // Realokace je výpočetně náročná => chcete co nejméně realokovat
        }
    }

    return arr;
}

int *histogram(size_t size)
{
    int *arr = (int *) calloc(size, sizeof(int));

    int* arr0 = malloc(size * sizeof(int));
    memset(arr0, 0, size * sizeof(int));

    if (arr == NULL) {
        return NULL;
    }

    bool error = false;

    int current = 0;
    while (scanf(" %d", &current) == 1) {
        if (current >= size || current < 0) {
            error = true;
            break;
        }

        arr[current] += 1;
    }

    return arr;
}

void lets_go_2d(int size)
{
    // int ??? arr =

    for (int i = 0; i < size; i++) {
        // ???
    }

    // How do u free it?
}
