#include <stdio.h>

struct demo_struct
{
    int x;
    int* ptr;
    char arr[3];
};

// zde neexistuje typ - je to globální
struct
{
    char mine: 1;
    char flag: 1;
    char revealed: 1;
    char number: 5;
} bit_field;


// zde neexistuje typ - je to globální => nepoužívat
enum {
    YELLOW,
    PURPLE,
    BLACK = 56,
} glob_colour;

void print_struct(struct demo_struct*);
void boxxing_demo();

int main(void) {
    // ENUM

    // rozdíl v deklaraci 

    ////////////////////////////

    // Co je to struktura?

    // Proč je chceme využívat

    // Jak je deklarujeme

    int a = 42;

    struct demo_struct var2 = {
        .x = 420,
        .arr = "ok",
        .ptr = &a,
    };

    print_struct(&var2);

    struct demo_struct var1 = {69, &a, "OK"};

    print_struct(&var1);

    // jak mít vše vynulované
    struct demo_struct var3 = { 0 };

    var3.x = 10;

    // Jak zde bude definovaný atribut arr?

    print_struct(&var3);

    printf("Velikost struktury: %zu\n", sizeof(struct demo_struct));
    printf("Velikost jednotlivých prvků: %zu %zu %zu\n\n", sizeof(var3.x), sizeof(var3.ptr), sizeof(var3.arr));

    // K čemu slouží ty :1 v deklaraci? Co tím simuluji? 
    printf("Velikost struktury: %zu\n", sizeof(bit_field));

    return 0;
}

void print_struct(struct demo_struct* structure) {
    // Proč chceme předávát struktury pomocí reference?

    // vypsat pomocí syntaktického cukru
    printf("X is: %d\n", structure->x);

    // vypsat pomocí dereference pokud existuje - *
    if ((*structure).ptr != NULL) {
        printf("ptr is: %d\n", *((*structure).ptr));
    }

    // vypsat string pokud existuje, jinak vypsat "NULL" - ternary
    printf("arr is: %s\n", structure->arr != NULL ? structure->arr : "NULL" );

    putchar('\n');
}

///////////////////////////////////

// Demo na union, enum, struct

// Co je Union, proč bych ho chtěl používat

enum structures {
    STRUC_1,
    STRUC_2,
    STRUC_3,
    DEMO,
};

struct struc_1 {
    int x;
    int *ptr;
    char str[20];
};

struct struc_2 {
    float x;
    float *ptr;
    char str[10];
};

struct struc_3 {
    char x;
    char *ptr;
};

union struc_type {
    struct struc_1 structure_1;
    struct struc_2 structure_2;
    struct struc_3 structure_3;
    struct demo_struct demo;
};

struct wrapper {
    enum structures structure_type;
    union struc_type structure;
};

void boxxing_demo(struct wrapper* input) {
    switch (input->structure_type) {
        case STRUC_1:
            struct struc_1 structure_1 = input->structure.structure_1;
            // print it out/do whatever
            break;
        case STRUC_2:
            struct struc_2 structure_2 = input->structure.structure_2;
            // print it out/do whatever
            break;
        case STRUC_3:
            struct struc_3 structure_3 = input->structure.structure_3;
            // print it out/do whatever
            break;
        case DEMO:
            struct demo_struct structure_demo = input->structure.demo;
            // print it out/do whatever
            break;
        default:
            fputs("Unknown structure type, please update code!", stderr);
    }
}