#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <stdlib.h>

#define ARR_LENGTH 7

uint64_t summer(int* arr, size_t lentgh) {
    if (lentgh == 0) {
        return 0;
    } 
    return *arr + summer(arr+1, lentgh-1);
}

void recursion(void) {
    // Co je to rekurze?

    // Jak vypadá běžná rekurzivní funkce? Co tam musí být?

    // Příklady použítí:

    int arr[ARR_LENGTH] = {5,2,3,6,4,7,9};

    printf("Result: %zu\n", summer(arr, ARR_LENGTH));

    // Jak přepsat rekurzi na cyklus => co k tomu potřebujeme?

    size_t stack_size = 4;
    uint64_t * stack = malloc(stack_size * sizeof(uint64_t));

    if (stack == NULL) {
        perror("Memory");
        exit(EXIT_FAILURE);
    }

    stack[0] = arr[0];

    for (size_t i = 1; i < ARR_LENGTH; i++)
    {
        if (i == stack_size + 1) {
            stack_size *= 2;
            uint64_t * tmp = realloc(stack, stack_size * sizeof(uint64_t));
            if (tmp == NULL) {
                perror("Memory");
                free(stack);
                exit(EXIT_FAILURE);
            }
            stack = tmp;
            tmp = NULL;
        }

        stack[i] = arr[i] + stack[i - 1];
    }

    printf("Result: %zu\n", stack[ARR_LENGTH - 1]);

    // jde tohle i jednodušeji? (tail rekurze)

    uint64_t sum = 0;

    for (size_t i = 0; i < ARR_LENGTH; i++)
    {
        sum += arr[i];
    }


}

struct competition
{
    char* name;
    int place;
};

void print_competition(struct competition * compet) {
    printf("Name: %s, Place: %d\n", compet->name, compet->place);
}

int compet_comparator (const void* a, const void* b) {
    struct competition arg1 = * (const struct competition *) a;
    struct competition arg2 = * (const struct competition *) b;

    // dle abecedy?
    int res;
    res = strcmp(arg1.name, arg2.name);

    if (res == 0) {
        return arg1.place > arg2.place ? 1 : -1;
    }

    return res;
}

void fnc_ptrs(void) {
    // Ukazatele na funkce => https://fuckingfunctionpointers.com/

    // Co? Proč? K čemu?

    // Sčítačka

    uint64_t (* my_summer) (int *, size_t) = summer;

    int arr[] = {1,2,3};

    printf("Result: %zu\n", my_summer(arr, 3));

    // qsort

    struct competition compet[3];

    compet[0].name = "Petr";
    compet[0].place = 3;
    compet[1].name = "Petr";
    compet[1].place = 2;
    compet[2].name = "Honza";
    compet[2].place = 1;

    for (size_t i = 0; i < 3; i++)
    {
        print_competition(compet + i);
    }
    
    putchar('\n');
    // Co když to chci mít podle abecedy?

    qsort(compet, 3, sizeof(struct competition), compet_comparator);
    
    for (size_t i = 0; i < 3; i++)
    {
        print_competition(compet + i);
    }
    putchar('\n');
    // A sekundárně dle umístění?
}

int main(void) {

    recursion();

    fnc_ptrs();

    return 0;
}