#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <stdlib.h>


int old_method(void) {
    void * mem1 = malloc(sizeof(int *));

    if (mem1 == NULL) {
        perror("mem1");
        return 1;
    }

    void * mem2 = malloc(sizeof(int *));

    if (mem2 == NULL) {
        perror("mem2");
        free(mem1);
        return 1;
    }

    void * mem3 = malloc(sizeof(int *));

    if (mem3 == NULL) {
        perror("mem3");
        free(mem1);
        free(mem2);
        return 1;
    }


    /*
          Do meaningfull stuff here
    */

   // free everything

    free(mem1);
    free(mem2);
    free(mem3);
    return 0;
}

int goto_showcase(void) {
    int ret_val = 0;

    void * mem1 = malloc(sizeof(int *));

    if (mem1 == NULL) {
        perror("mem1");
        ret_val = 1;
        goto end;
    }

    void * mem2 = malloc(sizeof(int *));

    if (mem2 == NULL) {
        perror("mem2");
        ret_val = 1;
        goto cleanup1;
    }

    void * mem3 = malloc(sizeof(int *));

    if (mem3 == NULL) {
        perror("mem3");
        ret_val = 1;
        goto cleanup2;
    }


    /*
          Do meaningfull stuff here
    */

    // pokud by se nám tady něco pokazilo a chtěli bychom vše uvolnit, tak jak?
    goto cleanup3;

    // free everything
cleanup3: 
    free(mem3);

cleanup2:
    free(mem2);

cleanup1:
    free(mem1);

end:
    return ret_val;
}

void free_arr(void ** arr) {
    // ne zase nutně sémanticky dobře => u FOR cyklu očekáváme, že vidíme jak dlouho poběží (přesný počet iterací)
    for (size_t i = 0; *(arr + i) != NULL; i++)
    {
        printf("Freeing address: %p\n", *(arr + i));
        free(*(arr + i));
    }
}

int another_variant(void) {
    void* memory_storage[4] = {0};

    memory_storage[0] = malloc(sizeof(int *));

    if (memory_storage[0] == NULL) {
        perror("mem1");
        return 1;
    }

    memory_storage[1] = malloc(sizeof(int *));

    if (memory_storage[1] == NULL) {
        perror("mem2");
        free_arr(memory_storage);
        return 1;
    }

    memory_storage[2] = malloc(sizeof(int *));

    if (memory_storage[2] == NULL) {
        perror("mem3");
        free_arr(memory_storage);
        return 1;
    }

    /*
          Do meaningfull stuff here
    */

    // pokud by se nám tady něco pokazilo a chtěli bychom vše uvolnit, tak jak?


    // free everything

    free_arr(memory_storage);

    return 0;
}

int main(void) {

    another_variant();

    // #########################
    // EXIT SUCCESS a EXIT FAILURE !
    // #########################

    // perror

    int i = 0;
    int ret_val = scanf(" %d", &i);

    if (ret_val != 1) {
        // proč je toto špatně?
        perror("Wrong number");
    }

    // Tímto zápisem říkáme "čekej pole" (tedy více prvků) ale bude tam jen jeden (jiný syntaktický význam) 

    // struct pcap_context context[1];

    // řešení => deklarovat si staticky tu strukturu a pak dále používat &

    // struct pcap_context context; ... &context

    return 0;
}
