#include <stdio.h>
//#include <io.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>

struct record {
    char *sureName;
    char *lastName;
    char *subject;
    char *grade;
};


struct record *createRecord(char* inputLine){
    struct record *record = malloc(sizeof(struct record));
    record->sureName = calloc(strlen(inputLine), sizeof(char));

    if (record->sureName == NULL )

    record->lastName = calloc(strlen(inputLine), sizeof(char));
    record->subject = calloc(strlen(inputLine), sizeof(char));
    record->grade = calloc(strlen(inputLine), sizeof(char));



    int splitCounter = 0;
    int index = 0;
    for (int i = 0; i < strlen(inputLine); i++){
        if (inputLine[i] == ';'){
            splitCounter++;
            index = 0;
            continue;
        }
        if (splitCounter == 0){
            record->sureName[index] = inputLine[i];
        }
        if (splitCounter == 1){
            record->lastName[index] = inputLine[i];
        }
        if (splitCounter == 2){
            record->subject[index] = inputLine[i];
        }
        if (splitCounter == 3){
            record->grade[index] = inputLine[i];
        }

        index++;
    }

    record->grade = calloc(1, strlen(inputLine));

    return record;
}

void emptyBuffer(char *inputLine){
    for (int i = 0; i < 200; i++){
        inputLine[i] = 0;
    }
}


int main(int argc, char* argv[])
{
    if (argc != 2){
        fprintf(stderr, "wrong argc\n");
        return 1;
    }
    FILE* fd = fopen(argv[1], "r");
    if (fd == NULL){
        fprintf(stderr, "file cant be open\n");
        return 2;
    }

    char inputLine[200] = {0};
    emptyBuffer(inputLine);


    struct record **records = malloc(sizeof(struct record*) * 5);
    int mallocSize = 5;
    int recordSize = 0;

    while (fscanf(fd,"%s\n", &inputLine) != EOF){
        printf("line: %s\n", inputLine);

        // dynamic memory work
        if (mallocSize < recordSize - 5){
            mallocSize *= 2;
            struct record **dynamicPointer = realloc(records, sizeof(struct record*) * mallocSize);
            if (dynamicPointer == NULL){
                free(records);
                perror("realloc fail\n");
                return 3;
            }
            records = dynamicPointer;
        }

        records[recordSize] = createRecord(inputLine);
        recordSize++;

        emptyBuffer(inputLine);
    }

    printf("\nrecords: %i\n\n", recordSize);

    for (int i = 0; i < recordSize; i++){
        printf("name: %s ,last name: %s, subject: %s , grades: %s\n",
               records[i]->sureName, records[i]->lastName, records[i]->subject, records[i]->grade);

    }


    fclose(fd);
    return 0;
}

// 'B' - 'A' + 1 == 2