#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>

#define A 1
#define B 2
#define C 3
#define D 4
#define E 5
#define F 6

#define NAME 1
#define SURNAME 2
#define CODE 3
#define GRADES 4

struct students
{
    struct student *first;
    struct student *last;
    size_t sum_of_stds;
};

struct student
{
    char *name;
    char *surname;
    char sub_code[5];
    char grades[3];
};
    
int alloc_mem(struct student *std, size_t *std_name_len, size_t *std_surname_len)
{

    (*std_name_len) = 10;

    std->name = malloc(sizeof(char) * (*std_name_len));

    if (std->name == NULL)
    {
        // malloc fprintf
        return 1;
    }

    std->surname = malloc(sizeof(char) * (*std_surname_len));

    if (std->surname == NULL)
    {
        // malloc fprintf
        return 1;
    }

    return 0;
}

int fill_std(struct student *std, char *val, int what_fill)
{

    if (what_fill == NAME)
    {
        strcpy(std->name, val);
    }
    else if (what_fill == SURNAME)
    {
        strcpy(std->surname, val);
    }
    else if (what_fill == GRADES)
    {
        strcpy(std->grades, val);
    }
    else if (what_fill == CODE)
    {
        strcpy(std->sub_code, val);
    }
    else
    {
        // bad value
        return 1;
    }

    return 0;
}

int main(int argc, char **argv)
{

    if (argc != 2)
    {
        fprintf(stderr, "Nespravny pocet argumentu");
        return 1;
    }

    FILE *file = fopen(argv[1], "r");

    if (file == NULL)
    {
        fprintf(stderr, "fopen");
        return 1;
    }

    char curr = getc(file);

    if (curr == EOF)
    {
        fprintf(stderr, "Prazny dokument");
        return 1;
    }

    struct students *data = malloc(sizeof(struct students));

    if (data == NULL)
    {
        fprintf(stderr, "malloc");
        return 1;
    }

    struct student *human = malloc(sizeof(struct student));

    if (human == NULL)
    {
        fprintf(stderr, "malloc");
        return 1;
    }

    data->first = human;
    data->last = human;
    // data->sum_of_stds++;

    // delka mista pro slova
    size_t curr_name_len = 10;
    size_t curr_surname_len = 10;

    if (alloc_mem(human, &curr_name_len, &curr_surname_len) != 0)
    {
        // chyba
        return 1;
    }

    char *curr_word = calloc(0, sizeof(char) * 32);

    if (curr_word == NULL)
    {
        // chzba
        return 1;
    }

    // kolik charu tam je
    size_t word_len = 0;

    // kolikatou polozku bereme
    int kolikata_pol = 0;

    while (curr != EOF)
    {
        kolikata_pol++;
        while (curr != '\n' && curr != EOF)
        {

            if (curr == ';')
            {
                fill_std(human, curr_word, kolikata_pol);

                kolikata_pol++;

                word_len = 0;
            }
            else
            {

                if (strncat(curr_word, &curr, sizeof(char)) == NULL)
                {
                    fprintf(stderr, "strncat\n");
                    return 1;
                }
            }
            curr = getc(file);
            word_len++;
        }

        if (curr == '\n' && curr != EOF)
        {
            struct students *human = malloc(sizeof(struct students));

            if (human == NULL)
            {
                fprintf(stderr, "malloc\n");
                return 1;
            }

            data->sum_of_stds++;
        }
    }


    return 0;
}